﻿using Infragistics.Controls.Charts;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Timers;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace PropertyChangedSample
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        System.Timers.Timer myTimer;
        BackgroundWorker bw = new BackgroundWorker();
        BackgroundWorker bw1 = new BackgroundWorker();
        public MainWindow()
        {
            InitializeComponent();
            myTimer = new System.Timers.Timer();
            myTimer.Elapsed += myTimer_Elapsed;
            myTimer.Interval = 5000;
            bw.DoWork += bw_DoWork;
            bw1.DoWork += bw1_DoWork;
        }

        void bw1_DoWork(object sender, DoWorkEventArgs e)
        {
            Dispatcher.Invoke(new Action(() =>
            {
                LoadFirstTime();
            }));
        }

        void bw_DoWork(object sender, DoWorkEventArgs e)
        {
            Dispatcher.Invoke(new Action(() =>
            {
                RefreshGraphOnPolling();
            }));
        }

        void myTimer_Elapsed(object sender, ElapsedEventArgs e)
        {
            if (bw.IsBusy != true)
            {
                bw.RunWorkerAsync();
            }
            myTimer.Start();
        }
        private void Button_Click(object sender, RoutedEventArgs e)
        {

            if (bw1.IsBusy != true)
            {
                bw1.RunWorkerAsync();
            }
        }
        private void LoadFirstTime()
        {
            try
            {
                wpfDataChart1.Series.Clear();
                int seriesCount = Convert.ToInt32(txtNoOfSeries.Text);

                for (int i = 0; i < seriesCount; i++)
                {
                    ScatterLineSeries series = new ScatterLineSeries();
                    series.XAxis = XAxis;
                    series.YAxis = YAxis;
                    series.MarkerType = MarkerType.Circle;
                    series.XMemberPath = "Xvalue";
                    series.YMemberPath = "Yvalue";
                    List<ChartLineData> data = new List<ChartLineData>();
                    int count = Convert.ToInt32(txtNoOfPOints.Text);
                    for (int j = i; j < count; j++)
                    {
                        data.Add(new ChartLineData() { Xvalue = i, Yvalue = j+5 });
                    }
                    series.ItemsSource = data;
                    wpfDataChart1.Series.Add(series);
                }
                myTimer.Interval = Convert.ToInt32(txtPollingDuration.Text);
                myTimer.Start();
            }
            catch (Exception)
            {
            }
        }
        private void RefreshGraphOnPolling()
        {
            foreach (Series item in wpfDataChart1.Series)
            {
                ((List<ChartLineData>)item.ItemsSource)[((List<ChartLineData>)item.ItemsSource).Count - 1].Yvalue += 5;
            }
        }
    }
}
